from argparse import ArgumentParser

def main() -> None:
    # Vytvoření parseru
    parser = ArgumentParser(description='Demo module for ordering pizza')

    # Poziční argumenty (povinné)
    parser.add_argument('address', help='Address for delivery', 
                        type=str)
    parser.add_argument('pizza', help='Type of pizza', 
                        choices=['Margherita', 'Funghi', '4Formaggi'])
    # Volba typu bool
    parser.add_argument('-x', '--spicy', 
                        help='Extra spicy', 
                        action='store_true')
    # Volba typu str s výběrem
    parser.add_argument('-s', '--size',
                        help='Pizza size', 
                        choices=['small', 'medium', 'large'],
                        default='medium')
    # Volba typu float
    parser.add_argument('-t', '--tip', 
                        help='Tip for the delivery ($)', 
                        type=float, 
                        default=0.0)
    
    # Načtení argumentů a voleb pomocí parseru
    args = parser.parse_args()

    print('Address:   ', args.address)
    print('Pizza type:', args.pizza)
    print('Size:      ', args.size)
    print('Spicy:     ', args.spicy)
    print('Tip:       ', args.tip)

if __name__ == '__main__':
    main()