"""
Auxiliary module for testing command-line programs using doctest - do not change!
"""


import sys
import difflib                    
from contextlib import redirect_stdout, redirect_stderr, suppress
from typing import TextIO
from pathlib import Path


class CLITesting:
    """Pomocná třída pro doctesty - neměňte!"""
    _module_name: str
    def __init__(self, module_name: str) -> None:
        self._module_name = module_name
    def run(self, command: str):
        run(command, self._module_name)


def run(command: str, module_name: str) -> None:
    """Pomocná funkce pro doctesty - neměňte!"""
    tested_module = sys.modules[module_name]
    sys.argv = [unquote(s) for s in command.split()[1:]]
    with redirect_stdout(SlashyWriter(sys.stdout)), redirect_stderr(SlashyWriter(sys.stdout)), suppress(SystemExit):
        tested_module.main()


def unquote(s: str) -> str:
    return s[1:-1] if s[0]==s[-1] and s[0] in ("'", '"') else s


def diff(file1: str, file2: str) -> None:                             
    """Pomocná funkce pro doctesty - neměňte!"""                     
    if not Path(file1).is_file():
        print(f"File '{file1}' not found")
        return
    if not Path(file2).is_file():
        print(f"File '{file2}' not found")
        return
    with open(file1, encoding='utf8') as f:                           
        lines1 = [line.rstrip() for line in f if line.rstrip() != ''] 
    with open(file2, encoding='utf8') as f:                           
        lines2 = [line.rstrip() for line in f if line.rstrip() != ''] 
    d = list(difflib.ndiff(lines1, lines2))                           
    success = all(line.startswith(' ') for line in d)                 
    if success:                                                       
        print('Files are identical')                                  
    else:                                                             
        print('Files are different:')                                 
        print('\n'.join(d))                                           


class SlashyWriter(TextIO):
    """'Pomocná třída pro doctesty - neměňte!"""
    def __init__(self, inner: TextIO) -> None: 
        self.inner = inner
    def write(self, s: str): 
        return self.inner.write(s.replace('\\', '/'))
    def writelines(self, lines): 
        list(map(self.write, lines))
    def flush(self): 
        return self.inner.flush()
